/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.workflow.action;

import jp.mosp.common.action.MosPWorkflowAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.workflow.dto.AmUnitDto;
import jp.mosp.workflow.vo.ApprovalUnitCardVo;

public class ApprovalUnitCardAction extends MosPWorkflowAction {

	// コマンド
	private static final String CMD_UNIT_CARD_SHOW   = "S2815";	// 表示(追加)
	private static final String CMD_UNIT_CARD_SELECT = "S2816";	// 表示(選択)
	private static final String CMD_UNIT_CARD_INSERT = "S2817";	// 登録
	private static final String CMD_UNIT_CARD_UPDATE = "S2818";	// 更新

	/**
	 * コンストラクタ
	 */
	public ApprovalUnitCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		ApprovalUnitCardVo vo = new ApprovalUnitCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		AmUnitDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof AmUnitDto ? (AmUnitDto)obj : null;
		// プルダウンのセット
		setPulldownList(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_UNIT_CARD_SHOW)) {
			vo.setDefaultValues();
			vo.setPltStartYear(String.valueOf(MospUtility.getYear(getStartDate(util.getSystemDate()))));
			vo.setPltStartMonth(String.valueOf(MospUtility.getMonth(getStartDate(util.getSystemDate()))));
			/*						
			 *  	2008/11/04	m.yoshida	修正
			 */
			vo.setPltStartDay(String.valueOf(MospUtility.getDay(getStartDate(util.getSystemDate()))));
			// モード設定
			setMode(vo);
		} else if (cmd.equals(CMD_UNIT_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = unitDao().findForKey(key1, key2);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			vo.setMode(ApprovalUnitCardVo.MODE_UPDATE);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_UNIT_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_UNIT_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * プルダウンの設定
	 * @param vo
	 * @throws Exception
	 */
	private void setPulldownList(ApprovalUnitCardVo vo) throws Exception {
		// DBコネクションの取得
		if (conn == null) {
			getConnection();
		}
		// MANAGER権限所有社員コード一覧
		vo.aryPltManager	= getBasisArrayForApproval();
		// 年
		vo.aryPltYear		= util.getYearArray(MospUtility.getYear(util.getSystemDate()), 10, 5);
		// 月
		vo.aryPltMonth		= util.getMonthArray();
		/*
		 * 		2008/11/06	m.yoshida	修正
		 */		
		// 日
		vo.aryPltDay		= util.getDayArray();
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private AmUnitDto insert(ApprovalUnitCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// 存在チェック
		chkDuplicate(unitDao().findForKey(vo.getTxtUnitCode(),
				util.convStringDateFormattedByHyphen(
						/*						
						 *  	2008/11/04	m.yoshida	修正
						 */
						vo.getPltStartYear(), vo.getPltStartMonth(), vo.getPltStartDay())
		), vo);
		// DTOの準備
		AmUnitDto dto = new AmUnitDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		// データの挿入
		unitDao().insert(dto);
		// DTOの再取得
		dto = unitDao().findForKey(dto.getUnitCode(), dto.getStartDate());
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalUnitCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private AmUnitDto update(ApprovalUnitCardVo vo, AmUnitDto dto) throws Exception {
		// コード取得
		vo.setTxtUnitCode(dto.getUnitCode());
		// 年月日取得
		vo.setPltStartYear(util.removeZero(util.divideByHyphen(dto.getStartDate(), 2)[0]));
		vo.setPltStartMonth(util.removeZero(util.divideByHyphen(dto.getStartDate(), 2)[1]));
		/*						
		 *  	2008/11/04	m.yoshida	修正
		 */
		vo.setPltStartDay(util.removeZero(util.divideByHyphen(dto.getStartDate(), 2)[2]));
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, unitDao().findForUpdate(vo.getTxtUnitCode(),
				util.convStringDateFormattedByHyphen(
						/*						
						 *  	2008/11/04	m.yoshida	修正
						 */
						vo.getPltStartYear(), vo.getPltStartMonth(), vo.getPltStartDay())
		), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		unitDao().update(dto);
		// DTOの再取得
		AmUnitDto retDto = unitDao().findForKey(dto.getUnitCode(), dto.getStartDate());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalUnitCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(ApprovalUnitCardVo vo) throws Exception {
		// モード設定
		if (vo.aryPltManager.length == 0) {
			vo.setMode(ApprovalUnitCardVo.MODE_IMPOSSIBLE);
		} else {
			vo.setMode(ApprovalUnitCardVo.MODE_INSERT);
		}
	}

}
